/*
 * CDIt v1.0 (C) 1997 Mikael Klasson
 *
 * Enjoy...
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <fcntl.h>
#include <string.h>

void processdir( char *, int );

FILE		*cfgfile;
int			mode = 0;	/* 	0 		=	normal
							1 		=	build
							2 		=	help 
							10 + i 	= 	normal, cmpstring at argv[i+1] */

struct match 
{
	int		charsright;
	char	dirname[256];
};

void main( int argc, char **argv )
{
	char			*configfile;
	char			tmpfilename[256];
	int				i, depth;
	struct match 	bestmatch;
	struct match 	test;
	char			*dirname[50];
	char			tmpuc;
	FILE			*tmpfile;

	configfile = getenv( "HOME" );

	sprintf( tmpfilename, "%s/.cdit_tmp", configfile );
	sprintf( configfile, "%s/.cdit_config", configfile );

	for( i = 1; i < argc; i++ )
	{
		if( !strcasecmp( argv[i], "-b" ) ) 		mode = 1;
		if( !strcasecmp( argv[i], "--build" ) ) mode = 1;
		if( !strcasecmp( argv[i], "-h" ) ) 		mode = 2;
		if( !strcasecmp( argv[i], "--help" ) ) 	mode = 2;
		if( !strcasecmp( argv[i], "-" ) ) 
		{
			mode = 10 + i;
			break;
		}
	}

	if( mode == 2 || argc < 2 )
	{
		printf( "CDIt v1.0\n" );
		printf( "Usage: cdit [OPTION] [-] DIRECTORY\n\n" );
		printf( "  -b, --build				build a new configfile\n" );
		printf( "  -h, --help				print this help message\n\n" );
		printf( "A single dash can be used to enable search for directories\n");
		printf( "with conflicting names, e.g \"--help\".\n" );
		return;
	}
	else if( mode == 1 )
	{
		if( !( cfgfile = fopen( configfile, "w" ) ) )
		{
			printf( "Couldn't open '%s' for writing!\n", configfile );
			perror( "Errormsg" );
			return;
		}

		printf( "Building database..." );
		fflush( stdout );
	
		processdir( "/", 0 );
	
		fclose( cfgfile );
		return;
	}

	if( mode > 10 ) mode -= 10;
	
	bestmatch.charsright = 0;
	bestmatch.dirname[0] = 0;

	if( !( cfgfile = fopen( configfile, "r" ) ) )
	{
		printf( "Couldn't open '%s' for reading!\n", configfile );
		printf( "You might wanna try \"cdit -b\" to build one...\n" );
		perror( "Errormsg" );
	}

	while( 1 )
	{
		depth = 0;
		while( ( tmpuc = fgetc( cfgfile ) ) == '/' ) depth++;
		if( tmpuc == EOF ) break;
		ungetc( tmpuc, cfgfile );
		fgets( test.dirname, 256, cfgfile );
		dirname[depth] = strdup( test.dirname );
		i = strlen( test.dirname ) - 1;
		dirname[depth][i] = 0;
		if( !strncmp( test.dirname, argv[mode+1], strlen( argv[mode + 1] ) ) )
		{
			bestmatch.charsright = test.charsright;
			bestmatch.dirname[0] = 0;
			for( i = 0; i <= depth; i++ )
			{
				strcat( bestmatch.dirname, "/" );
				strcat( bestmatch.dirname, dirname[i] );
			}
			if( strlen( argv[mode + 1] ) == bestmatch.charsright ) break;
		}
	}

	if( bestmatch.dirname ) 
	{
		sprintf( test.dirname, "cd %s", bestmatch.dirname );
		if( !( tmpfile = fopen( tmpfilename, "w" ) ) ) 
		{
			printf( "Couldn't open '%s' for writing!\n", tmpfilename );
			printf( "This is necessary for CDIt to work, sorry...\n" );
			perror( "Errormsg" );
		}
		else
		{
			fprintf( tmpfile, "# Used by CDIt to actually perform the cd...\n\n" );
			fprintf( tmpfile, "%s\n", test.dirname );
			fclose( tmpfile );
		}
	}
	
	fclose( cfgfile );
	return;
}

void processdir( char *dirname, int depth )
{
	struct dirent	*dir_ent;
	struct DIR	*dir;
	struct stat	fileflags;
	int		i;

	putchar( '.' );
	fflush( stdout );

	if( !chdir( dirname ) )
	{
		if( dir = opendir( "." ) )
		{
			while( dir_ent = readdir( dir ) )
			{
				lstat( dir_ent->d_name, &fileflags );
				if( S_ISDIR( fileflags.st_mode ) && !S_ISLNK( fileflags.st_mode ) && strcmp( dir_ent->d_name, "." ) && strcmp( dir_ent->d_name, ".." ) ) 
				{
					for( i = 0; i < depth; i++ ) fputc( '/', cfgfile );
					fprintf( cfgfile, "%s\n", dir_ent->d_name );
					processdir( dir_ent->d_name, depth + 1 );
				}
			}
			closedir( dir );
		}
		if( depth ) chdir( ".." );
	}
	return;
}